/* xover.c */

#include "common.h"

#ifdef XOVER
static FILE *xover_fp;
static int xover_num;

void
doxover(argc, argv)
	int		argc;
	char		*argv[];
{
	register FILE	*fp;
	register int	c, first, last;
	int		artnum, artp;
	char		*p;

	if (!canread) {
		printf("%d You only have permission to transfer, sorry.\r\n",
			ERR_ACCESS);
		(void) fflush(stdout);
		return;
	}

	if (!ingroup) {
		printf("%d You are not currently in a newsgroup.\r\n",
			ERR_NCING);
		(void) fflush(stdout);
		return;
	}
	if (argc != 1 && argc != 2) {
		printf("%d Usage: XOVER [first[-last]].\r\n", ERR_CMDSYN);
		(void) fflush(stdout);
		return;
	}

	if (xover_fp)
		fp = xover_fp;
	else {
		fp = xover_fp = fopen(".overview", "r");
		if (fp == NULL) {
			printf("%d No overview available.\r\n", ERR_FAULT);
			(void) fflush(stdout);
#ifdef SYSLOG
			syslog(LOG_ERR, "xover: fopen %s: %m", ".overview");
#endif
			return;
		}
		xover_num = 0;
	}

	if (argc == 1) {
		if (art_ptr < 0 || art_ptr >= num_arts) {
			printf("%d No article is currently selected.\r\n",
				ERR_NOCRNT);
			(void) fflush(stdout);
			return;
		}
		first = last = art_array[art_ptr];
	} else {
		p = index(argv[1], '-');
		if (p == NULL)
			first = last = atoi(argv[1]);
		else {
			*p++ = '\0';
			first = atoi(argv[1]);
			last = atoi(p);
		}
		if (first < 1)
		    first = 1;
		if (last > art_array[num_arts-1])
		    last = art_array[num_arts-1];
	}
	/* Return the desired data.  This is written carefully to avoid
	 * over-long lines. */
	printf("%d overview data follows\r\n", OK_OVER);
	if (first < xover_num || !xover_num) {
		fseek(fp, 0L, 0);
		xover_num = 0;
	}
	if (xover_num) {
		artnum = xover_num;
		xover_num = 0;
	} else
		fscanf(fp, "%d", &artnum);
	artp = 0;
	while (!feof(fp)) {
		if (artnum > last) {
			xover_num = artnum;
			break;
		}
		while (art_array[artp] < artnum)
		    artp++;
		if (artnum >= first && artnum == art_array[artp]) {
			printf("%d", artnum);
			while ((c = getc(fp)) != EOF && c != '\n')
				putchar(c);
			printf("\r\n");
		} else
			while ((c = getc(fp)) != EOF && c != '\n')
				continue;
		fscanf(fp, "%d", &artnum);
	}
	printf(".\r\n");
	(void) fflush(stdout);
}

void
close_xover()
{
	if (xover_fp) {
		fclose(xover_fp);
		xover_fp = NULL;
	}
}
#endif
