.ND
.TL
USENET - A General Access
.UX
Network
.AU
Stephen Daniel, James Ellis, and Tom Truscott
.AI
Duke University
.PP
A group of
.UX
systems
at Duke University and the University of North Carolina, Chapel Hill,
have established a uucp-based computer communication network.
Admission to the net is open to all
.UX
licensees.
In addition to providing the "uu" services
available in the Seventh Edition of
.UX
(remote mail, file transfer, job execution),
it provides a network news service.
A prospective system must have a call-in facility,
call-out facility, or some other means
of communication with another
.UX
net system.
The system must have, or be able to legitimately obtain,
uucp and related software.
.PP
Systems which do not call-out to the net
must be polled occasionally.
We will poll any system that so requests,
and will bill the polled system for phone costs.
Phone costs are typically $10-$20/month.
There are no connection fees or other charges
for using the network.
Requests for an application should be sent to
.DS
James Ellis
Department of Computer Science
Duke University
Durham, NC   27706
Telephone: (919) 684-3048
.DE
.SH
SERVICES
.PP
A goal of USENET has been to give every UNIX system
the opportunity to join and benefit from a computer network
(a poor man's ARPANET, if you will).
New systems will probably find
that the rapid access newsletter
is the initially most significant service.
Via
.I news
(available on the Delaware conference distribution tape),
any system can submit an article
which will in due course propagate to all other interested systems.
Most articles concern bug fixes,
requests for help,
and general information.
.PP
The mail command provides a convenient means for responding
to intriguing articles.
In general,
small groups of users with common interests
use mail to communicate.
If the group size grows sufficiently,
they can start a new "newsgroup"
(this will be discussed later).
.PP
It is hoped that USENIX will take an active
(indeed central)
role in the network.
There is the problem of members not on the net,
so hardware newsletters should remain
the standard communication method.
However,
use of the net for preparation of newsletters
seems like a good idea.
.SH
NEWS
.PP
.I News
is designed to meet the
information interchange needs of
large communities of computer users.
Through the mechanism of "newsgroups",
.I news
minimizes file space usage
and network traffic
while allowing multiple, overlapping
interest groups to coexist and dynamically evolve.
Conceptually, a newsgroup is a name for a
category of news articles.
Users on a given system may individually subscribe
and submit articles to
arbitrary sets of newsgroups.
When a user runs
.I news,
articles matching that user's interests are presented.
Various options may be specified to
permit the reading of
old news or
news from other newsgroups.
.PP
Remote systems can also subscribe to newsgroups
on an individual basis.
For each such system,
a subscription list and a transmission
protocol are maintained.
Whenever an article should be sent to a remote system,
the transmission protocol for that system is
executed with a
formatted version of the article as input.
This program performs the necessary magic
to send an article to the news program
on the remote system.
This might, for example, be done by remote execution of
.I news,
or the article could be encapsulated
and mailed to the remote system,
where another program
would recover it
and pass it on to the local news program.
.PP
The individual system subscription lists
also allow the creation of subnetworks.
For example,
the systems near Duke all subscribe to
the newsgroup "triangle"
which is used for colloquium announcements
and other items of local interest.
.PP
Duke's news is used primarily for articles of strictly local interest;
however, the ones off the net tend to be more interesting.
For example, there have been over a dozen bug reports,
about half of which have suggested fixes.
Two different bugs were found in the kernel's swapping code:
one may cause the swap area to be trashed,
the other may cause a user to lose his floating point registers.
(A fix was given in each case.)
There have also been several articles of more general interest,
such as how to get a draft copy
of the IEEE assembly language standard.
.SH
QUESTIONS ANSWERED
.IP 1.
Isn't this expensive?
.br
Not at all.
Night time phone costs are about $0.50/3 minutes,
in which time uucp can transfer about
3000 bytes of data (300 baud).
Daily polling then costs $15/Month,
which is half what Duke pays
just for an office phone.
.IP 2.
Can Duke really handle all the phone calls?
.br
Sure.
We have two call-out lines:
at five minutes/call,
we can handle 24 calls/hour.
Other systems also
perform the call-out function.
.IP 3.
What about abuse of the network?
.br
In general, it will be straightforward
to detect when abuse has occurred
and who did it.
The uucp system, like
.UX ,
is not designed to prevent abuses
of overconsumption.
Experience will show what uses of the net
are in fact abuses,
and what should be done about them.
.IP
Certain abuses of the net
can be serious indeed.
As with ordinary abuses,
they can be thought about,
looked for,
and even programmed against,
but only experience will show what matters.
Uucp provides some measure of protection.
It runs as an ordinary user,
and has strict access controls.
It is safe to say that it poses no greater threat
than that inherent in a call-in line.
.IP 4.
Who would be responsible when something bad happens?
.br
Not us!
And we do not intend that any innocent bystander
be held liable either.
We are looking into this matter.
Suggestions are solicited.
.IP 5.
Okay, so a few systems have the net started. What next?
